;******************************************************************************
;                                                                             *
;     : Stab.ASM                                                      *
;    : 21.05.2014                                                        *
;    : 2.1                                                              *
;                                                                             *
;    :                                                       *
;                                                                             *
;******************************************************************************
;                                                                             *
;    : PIC16F684                                               *
;    :  , 4 M.                                  *
;    : .                                                              *
;                                                                             *
;******************************************************************************
;                                                                             *
;     :                                                      *
;        PIC16F684-I/P.                 *
;               *
;        .                                    *
;          10%  100%   10%.   *
;        .                                           *
;                      *
;     .                                                *
;       5,00 .                                         *
;                                                                             *
;******************************************************************************
;                                                                             *
;    : 1506    .                             *
;                                                                             *
;******************************************************************************

;------------------------------------------------------------------------------
;   :
;------------------------------------------------------------------------------
            LIST        P=16F684    ; PIC16F684
;------------------------------------------------------------------------------
;   :
;------------------------------------------------------------------------------
            __CONFIG    300Ch       ; (0011 0000 0000 1100)
                                    ; WDT - .(on, enabled)
                                    ; PWRT - .(on, enabled)
                                    ; CP - .(on, enabled)
                                    ; CPD - .(on, enabled)
                                    ; BOR - .(off, disabled)
                                    ; RA3 -  .
;------------------------------------------------------------------------------
;     .
;------------------------------------------------------------------------------
PCL         equ         02h         ;  PCL,    .
PCLATH      equ         0Ah         ;  PCLATH.
Status      equ         03h         ;   .
TrisA       equ         85h         ;    
                                    ;  PORTA.
TrisC       equ         87h         ;    
                                    ;  PORTC.
PortA       equ         05h         ;     PORTA.
PortC       equ         07h         ;     PORTC.
IntCon      equ         0Bh         ;  INTCON.
Cmcon0      equ         19h         ;   .
Ansel       equ         91h         ;    .
Option_Reg  equ         81h         ;  OPTION.
WpuA        equ         95h         ;   
                                    ;   PORTA.
Osccon      equ         8Fh         ;    .

AdresH      equ         1Eh         ;
AdCon0      equ         1Fh         ;
AdCon1      equ         9Fh         ;

EEData      equ         9Ah         ;  EEData - .
EEAdr       equ         9Bh         ;  EEAdr - .
EECon1      equ         9Ch         ;  EECon1.
EECon2      equ         9Dh         ;  EECon2.

T2Con       equ         12h         ;     TMR2.
CCP1Con     equ         15h         ;    CCP.
CCPR1L      equ         13h         ;    CCP.
PR2         equ         92h         ;   .
TMR2        equ         11h         ;  TMR2.
PIR1        equ         0Ch         ;   .  
;------------------------------------------------------------------------------
;       .
;------------------------------------------------------------------------------
Adres       equ         72h         ;
ResultH     equ         29h         ;  .
Oprnapr     equ         2Ah         ; 
ProvPred    equ         2Ch         ; .
SecL        equ         22h         ;   .
SecM        equ         21h         ;   .
SecH        equ         20h         ;   .
VybSchim    equ         36h         ;
Predelmax   equ         35h         ;
Ust         equ         34h         ;   .
CCPinv      equ         32h         ;
Max         equ         31h         ; 
TaimerL     equ         30h         ;  .
;------------------------------------------------------------------------------
;     .
;------------------------------------------------------------------------------
W           equ         0x00        ;    .
F           equ         0x01        ;    .
;------------------------------------------------------------------------------
;                     .
;                (    )
;------------------------------------------------------------------------------
RA0         equ         0x00        ;  "+".
RA1         equ         0x01        ;  "-".
RA2         equ         0x02        ;  "/".
RA3         equ         0x03        ; ,  .
RA4         equ         0x04        ; , ,    .
RA5         equ         0x05        ; , , / .
RC0         equ         0x00        ;  "1".
RC1         equ         0x01        ;  "2".
RC2         equ         0x02        ;  "4".
RC3         equ         0x03        ;  .
RC4         equ         0x04        ;  "8".
RC5         equ         0x05        ;  .

RP0         equ         0x05        ;   .
Z           equ         0x02        ;   .
C           equ         0x00        ;
ADON        equ         0x00        ; .
GO          equ         0x01        ; .
RD          equ         0x00        ;
WR          equ         0x01        ;
WREN        equ         0x02        ;
TMR2IF      equ         0x01        ;     TMR2.
;------------------------------------------------------------------------------
; EEPROM
;------------------------------------------------------------------------------
            org         2100h
            DE          0x04        ;  0x00 - . (0x00...0x09)
;------------------------------------------------------------------------------
;    .
;------------------------------------------------------------------------------
            org         0x00        ;    
                                    ;   PC.
            goto        St          ;    
                                    ;  St.
;------------------------------------------------------------------------------
;    .
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
;  .
;------------------------------------------------------------------------------
St          bsf         Status,RP0  ;   1- .
            movlw       0x60        ; (0110 0000)
            movwf       Osccon      ;   4 .
            bcf         Status,RP0  ;   0- .
            clrf        IntCon      ;   .
            clrf        PortA       ;     PortA  .
            clrf        PortC       ;     PortC  .
            clrf        TMR2        ;     TMR2  .
            clrf        Ust         ;     Ust  .
Start       bsf         Status,RP0  ;   1- .
            movlw       0x60        ; (0110 0000)
            movwf       Osccon      ;   4 .
            movlw       0x0F        ; (0000 1111)
            movwf       TrisA       ; 1-, 0-.
            movlw       0x08        ; (0000 1000)
            movwf       TrisC       ; 1-, 0-.
            movlw       0x6F        ; (0110 1111)
            movwf       Option_Reg  ;   .
            movlw       0x07        ; (0000 0111)
            movwf       WpuA        ;    
                                    ; RA0, RA1, RA2  .
            movlw       0x80        ; (1000 0000)
            movwf       Ansel       ;   AN7 (RC3), 
                                    ;  \.
            movlw       0x50        ; Fosc/16 (0101 0000).
            movwf       AdCon1      ; 

            movlw       0xF9        ;    , 249.
            movwf       PR2         ; 1000 

            bcf         Status,RP0  ;   0- .
            movlw       0x07        ; (0000 0111)
            movwf       Cmcon0      ;  .
            clrf        IntCon      ;   .
            clrwdt                  ;    WDT.
            bsf         PortC,RC5   ;    RC5 .
;------------------------------------------------------------------------------
;  .
;------------------------------------------------------------------------------
            btfss       PortA,RA2   ;    (RA2 = 1),     call Zad50ms.
            goto        $+3         ;    (RA2 = 0),      .
            call        Zad50ms     ;   50 .
            goto        $-3         ;
            call        Zad50ms     ;   50 .
            btfss       PortA,RA2   ;    (RA2 = 1),     movlw 0x1D.
            goto        $-2         ;    (RA2 = 0),      .
;------------------------------------------------------------------------------
; :           .
;------------------------------------------------------------------------------
            movlw       0x1D        ; (0001 1101) AN7,  ,
            movwf       AdCon0      ;    
                                    ;  .
            call        Zad18mks    ;   18 .
            bsf         AdCon0,GO   ;  , 
                                    ;      .
            btfsc       AdCon0,GO   ;
            goto        $-1         ;
            movf        AdresH,W    ;    
            movwf       ResultH     ;   AdresH   ResultH.
            bcf         AdCon0,ADON ;  .
            movlw       0x5C        ; 92+1=93 - 182 B (1,82 B),  .
            movwf       Oprnapr     ;
Sn          incf        Oprnapr,F   ;     Oprnapr.
            movf        ResultH,W   ;    ResultH
                                    ;   W.         
            xorwf       Oprnapr,W   ;  "-" 
                                    ;  W  Oprnapr.
            btfss       Status,Z    ;  Z=1,     goto Sch.
            goto        $+2         ;
            goto        Sch         ;

            movlw       0xBA        ; 186 - 365 B (3,65 B),  .
            xorwf       Oprnapr,W   ;  "-" 
                                    ;  W  Oprnapr.
            btfss       Status,Z    ;  Z=1,   
                                    ;  movlw 0x69.
            goto        Sn          ;

            movlw       0x69        ;    W  105.
            subwf       ResultH,F   ;    W 
                                    ;   ResultH
                                    ;      .
            btfsc       Status,C    ;  C=1,       .
            goto        $+3         ;
            bsf         PortA,RA4   ;    RA4 .
            goto        Sch         ;

            movlw       0x30        ;   CCP.
            movwf       CCP1Con     ;   .
            movlw       0x01        ; TMR2 . . = 4.
            movwf       T2Con       ; .  = 0.

            movlw       0x20        ;    W  32.
            movwf       PortC       ;    W
                                    ;   PortC.
            bsf         PortA,RA4   ;    RA4 .
            bsf         PortC,RC5   ;    RC5 .
            bcf         PortA,RA5   ;    RA5 .
            goto        Stop        ;
;------------------------------------------------------------------------------
;   CCP.   .
;------------------------------------------------------------------------------
Sch         bsf         PortA,RA5   ;    RA5 .
            clrf        CCPR1L      ;     CCPR1L  .
            movlw       0x1C        ;   CCP.
            movwf       CCP1Con     ;   .
            movlw       0x05        ; TMR2 . . = 4.
            movwf       T2Con       ; .  = 0.
;------------------------------------------------------------------------------
; :   EEPROM. .
;------------------------------------------------------------------------------
            clrf        Adres       ;     Adres  .
            movf        Adres,W     ;    Adres
                                    ;   W.
            bsf         Status,RP0  ;   1- .
            movwf       EEAdr       ;    W
                                    ;   EEAdr.
            bsf         EECon1,RD   ;   EEPROM.
            btfsc       EECon1,RD   ;   ,     movf EEData,W.
            goto        $-1         ;    ,      .
            movf        EEData,W    ;    EEData
                                    ;   W.
            bcf         Status,RP0  ;   0- .
            movwf       Ust         ;    W
                                    ;   Ust.
            goto        Perehod     ;    Perehod.
;------------------------------------------------------------------------------           
Opros       clrwdt                  ;    WDT.
            btfss       PortA,RA0   ;    (RA0 = 1),     btfss PortA,RA1.
            goto        Plus        ;    (RA0 = 0),     goto Plus.
            btfss       PortA,RA1   ;    (RA1 = 1),     btfss PortA,RA2.
            goto        Minus       ;    (RA1 = 0),     goto Minus.
            btfss       PortA,RA2   ;    (RA2 = 1),     btfss PortA,RA3.
            goto        Vykl        ;    (RA2 = 0),     goto Vykl.
            goto        Perehod     ;    Perehod.
;------------------------------------------------------------------------------
Plus        incf        Ust,F       ;   Ust      .
            movlw       0x0A        ;    W  10. 
            xorwf       Ust,W       ;  "-"
                                    ;   W  Ust.
            btfss       Status,Z    ;  Z=0,     goto $+3.
            goto        $+3         ;  Z=1 (  ),     decf Ust,F.
            decf        Ust,F       ;   Ust      .
            goto        $+2         ;     .
            call        ZapEEPROM   ;    ZapEEPROM  .
            call        Zad50ms     ;   50 .
            btfss       PortA,RA0   ;    (RA0 = 1),     goto Perehod.
            goto        $-2         ;    (RA0 = 0),      .
            goto        Perehod     ;    Perehod.
;------------------------------------------------------------------------------
Minus       decf        Ust,F       ;   Ust      .
            movlw       0xFF        ;    W  255. 
            xorwf       Ust,W       ;  "-"
                                    ;   W  Ust.
            btfss       Status,Z    ;  Z=0,     goto $+3.
            goto        $+3         ;  Z=1 (  ),     incf Ust,F.
            incf        Ust,F       ;   Ust      .
            goto        $+2         ;     .
            call        ZapEEPROM   ;    ZapEEPROM  .
            call        Zad50ms     ;   50 .
            btfss       PortA,RA1   ;    (RA1 = 1),    Perehod.
            goto        $-2         ;    (RA1 = 0),      .
;------------------------------------------------------------------------------
Perehod     movlw       0x00        ;    W  0.
            movwf       PCLATH      ;    W   PCLATH.
            movf        Ust,W       ;    Ust
                                    ;   W.
            addwf       PCL,F       ;     
                                    ;       W.
            goto        Predel10    ;    Predel10.
            goto        Predel20    ;    Predel20.
            goto        Predel30    ;    Predel30.
            goto        Predel40    ;    Predel40.
            goto        Predel50    ;    Predel50.
            goto        Predel60    ;    Predel60.
            goto        Predel70    ;    Predel70.
            goto        Predel80    ;    Predel80.
            goto        Predel90    ;    Predel90.
            goto        Predel100   ;    Predel100.
;------------------------------------------------------------------------------
;  \.
;------------------------------------------------------------------------------
Vykl        movlw       0x30        ;   CCP.
            movwf       CCP1Con     ;   .
            movlw       0x01        ; TMR2 . . = 4.
            movwf       T2Con       ; .  = 0.
            movlw       0x20        ; (0010 0000)
            movwf       PortC       ; 
            bcf         PortA,RA4   ;    RA4 .
            bcf         PortA,RA5   ;    RA5 .

            call        Zad50ms     ;   50 .
            btfss       PortA,RA2   ;    (RA2 = 1),     call Zad50ms.
            goto        $-2         ;    (RA2 = 0),      .

            call        Zad50ms     ;   50 .
            btfsc       PortA,RA2   ;    (RA2 = 0),     Start.
            goto        $-2         ;    (RA2 = 1),      .
            goto        Start       ;     Start.           
;------------------------------------------------------------------------------
;    EEPROM.
;------------------------------------------------------------------------------         
ZapEEPROM   clrf        Adres       ;     Adres  .
            movf        Ust,W       ;    Ust
                                    ;   W.
            bsf         Status,RP0  ;   1- .
            movwf       EEData      ;    W
                                    ;   EEData.
            movf        Adres,W     ;    Adres
                                    ;   W.
            movwf       EEAdr       ;    W
                                    ;   EEAdr.
            bsf         EECon1,WREN ;    EEPROM (WREN=1).
            movlw       055h        ;  055h
            movwf       EECon2      ;
            movlw       0AAh        ;  0AAh
            movwf       EECon2      ;
            bsf         EECon1,WR   ;  .
            clrwdt                  ;    WDT.
            btfsc       EECon1,WR   ;   ,     clrf EECon1.
            goto        $-1         ;    ,      .
            clrf        EECon1      ;    
                                    ; EECon1  .
            bcf         Status,RP0  ;   0- .
            return                  ;     .
;------------------------------------------------------------------------------
;  CCP.
;------------------------------------------------------------------------------
CCP         movwf       CCPinv      ;    W
                                    ;   CCPinv.
            comf        CCPinv,F    ;      CCPinv.
            movf        CCPinv,W    ;    CCPinv
                                    ;   W.
            bcf         PIR1,TMR2IF ;      TMR2.
            btfss       PIR1,TMR2IF ;   
            goto        $-1         ;    TMR2.
            movwf       CCPR1L      ;    W
                                    ;   CCPR1L.
            return                  ;     .
;------------------------------------------------------------------------------
;  ADC.
;------------------------------------------------------------------------------
ADC         clrf        Predelmax   ;     Predelmax  .
            movlw       0xFF        ; 
            movwf       VybSchim    ;
            movlw       0x1D        ; (0001 1101) AN7,  ,
            movwf       AdCon0      ;    
                                    ;  .
            call        Zad18mks    ;   18 .
            bsf         AdCon0,GO   ;  , 
                                    ;      .
            btfsc       AdCon0,GO   ;
            goto        $-1         ;
            movf        AdresH,W    ;    
            movwf       ResultH     ;   AdresH   ResultH.
            bcf         AdCon0,ADON ;  .
            movlw       0x5C        ; 92+1=93 - 182 B (1,82 B),  .
            movwf       Oprnapr     ;
Snova       incf        VybSchim,F  ;     VybSchim.
            incf        Oprnapr,F   ;     Oprnapr.
            movf        ResultH,W   ;    ResultH
                                    ;   W.         
            xorwf       Oprnapr,W   ;  "-" 
                                    ;  W  Oprnapr.
            btfss       Status,Z    ;  Z=1,     btfsc Max,0.
            goto        $+7         ;

            btfsc       Max,0       ;
            goto        $+3         ;
            bcf         PortA,RA4   ;    RA4 .
            goto        $+2         ;
            bsf         PortA,RA4   ;    RA4 .
            goto        YesPred     ;


            movlw       0xBA        ; 186 - 365 B (3,65 B),  .
            xorwf       Oprnapr,W   ;  "-" 
                                    ;  W  Oprnapr.
            btfss       Status,Z    ;  Z=1,   
                                    ;  movlw 0x69.
            goto        Snova       ;

            movlw       0x69        ;    W  105.
            subwf       ResultH,F   ;    W 
                                    ;   ResultH
                                    ;      .
            btfsc       Status,C    ;  C=1,       .
            goto        $+5         ;
            movlw       0x00        ; 
            movwf       VybSchim    ;
            bsf         PortA,RA4   ;    RA4 .
            goto        YesPred     ;

            movlw       0x30        ;   CCP.
            movwf       CCP1Con     ;   .
            movlw       0x01        ; TMR2 . . = 4.
            movwf       T2Con       ; .  = 0.

            movlw       0x20        ;    W  32.
            movwf       PortC       ;    W
                                    ;   PortC.
            bsf         PortA,RA4   ;    RA4 .
            bsf         PortC,RC5   ;    RC5 .
            bcf         PortA,RA5   ;    RA5 .

            bsf         Predelmax,0 ;      Predelmax .
            goto        $+2         ;
YesPred     movf        VybSchim,W  ;    VybSchim
                                    ;   W.
            return                  ;     .
;------------------------------------------------------------------------------
;  Stop.
;------------------------------------------------------------------------------
Stop        call        Zad50ms     ;   50 .
            btfsc       PortA,RA2   ;    (RA2 = 0),     movlw 0x20.
            goto        $-2         ;    (RA2 = 1),      .

            movlw       0x20        ; (0010 0000)
            movwf       PortC       ;
            bcf         PortA,RA4   ;    RA4 .
            bcf         PortA,RA5   ;    RA5 .

            call        Zad50ms     ;   50 .
            btfss       PortA,RA2   ;    (RA2 = 1),     call Zad50ms.
            goto        $-2         ;    (RA2 = 0),      .

            call        Zad50ms     ;   50 .
            btfsc       PortA,RA2   ;    (RA2 = 0),     Start.
            goto        $-2         ;    (RA2 = 1),      .            
            goto        Start       ;     Start.
;------------------------------------------------------------------------------
;  Zad18mks (  18 ), 4 .
;------------------------------------------------------------------------------
Zad18mks    movlw       0x05        ;    W  5.
            movwf       SecL        ;    W   SecL.
            decfsz      SecL,F      ;    SecL.
            goto        $-1         ;      ,
                                    ;      .
            clrwdt                  ;    WDT.
            return                  ;     .
;------------------------------------------------------------------------------
;  Zad50ms (  50 ), 4 .
;------------------------------------------------------------------------------
Zad50ms     movlw       0xD8        ;    W  216.
            movwf       SecL        ;    W   SecL.
            movlw       0x41        ;    W  65.
            movwf       SecM        ;    W   SecM.
            decfsz      SecL,F      ;    SecL.
            goto        $-1         ;      ,
                                    ;      .
            clrwdt                  ;    WDT.
            decfsz      SecM,F      ;    SecM.
            goto        $-4         ;      ,
                                    ;      .
            return                  ;     .
;------------------------------------------------------------------------------
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
;------------------------------------------------------------------------------
;  Predel100. 100%.
;------------------------------------------------------------------------------
Predel100   movlw       0x12        ;  .    W  18.
            movwf       PortC       ;    W
                                    ;   PortC.
            movlw       0x01        ;    W  1.
            movwf       PCLATH      ;    W   PCLATH.
            movlw       0x1A        ;    W  26.
            movwf       TaimerL     ;    W   TaimerL.
Nazad100    call        ADC         ;
            btfsc       Predelmax,0 ;
            goto        Stop        ;
            call        Table100    ;
            call        CCP         ;
;------------------------------------------------------------------------------
            movwf       ProvPred    ;    W
                                    ;   ProvPred.
            movlw       0x00        ;    W  0.
            xorwf       ProvPred,W  ;  "-" 
                                    ;  W  ProvPred.
            btfsc       Status,Z    ;  Z=1,   
                                    ;  bsf Max,0.
            goto        $+3         ;
            bcf         Max,0       ;      Max .
            goto        $+2         ;
            bsf         Max,0       ;      Max .
;------------------------------------------------------------------------------
            decfsz      TaimerL,F   ;    TaimerL.
            goto        Nazad100    ;      ,
                                    ;     Nazad100.
            goto        Opros       ;     ,
                                    ;     Opros.
;------------------------------------------------------------------------------
Table100    addwf       PCL,F       ;     
                                    ;       W.
            retlw       0xFF        ; 255; 182 B;  0.
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255
            retlw       0xFF        ; 255; 220 B;  19.
            retlw       0xFB        ; 251
            retlw       0xF7        ; 247
            retlw       0xF3        ; 243
            retlw       0xEF        ; 239
            retlw       0xEB        ; 235
            retlw       0xE7        ; 231
            retlw       0xE3        ; 227
            retlw       0xE0        ; 224
            retlw       0xDC        ; 220
            retlw       0xD8        ; 216
            retlw       0xD5        ; 213
            retlw       0xD2        ; 210
            retlw       0xCE        ; 206
            retlw       0xCB        ; 203
            retlw       0xC8        ; 200
            retlw       0xC5        ; 197
            retlw       0xC2        ; 194
            retlw       0xBF        ; 191
            retlw       0xBC        ; 188
            retlw       0xBA        ; 186
            retlw       0xB7        ; 183
            retlw       0xB4        ; 180
            retlw       0xB2        ; 178
            retlw       0xAF        ; 175
            retlw       0xAD        ; 173
            retlw       0xAA        ; 170
            retlw       0xA8        ; 168
            retlw       0xA6        ; 166
            retlw       0xA3        ; 163
            retlw       0xA1        ; 161
            retlw       0x9F        ; 159
            retlw       0x9D        ; 157
            retlw       0x9B        ; 155
            retlw       0x99        ; 153
            retlw       0x97        ; 151
            retlw       0x95        ; 149
            retlw       0x93        ; 147
            retlw       0x91        ; 145
            retlw       0x8F        ; 143
            retlw       0x8D        ; 141
            retlw       0x8B        ; 139; 300 ;  60.
            retlw       0x8A        ; 138
            retlw       0x88        ; 136
            retlw       0x86        ; 134
            retlw       0x85        ; 133
            retlw       0x83        ; 131
            retlw       0x81        ; 129
            retlw       0x80        ; 128
            retlw       0x7E        ; 126
            retlw       0x7D        ; 125
            retlw       0x7B        ; 123
            retlw       0x7A        ; 122
            retlw       0x79        ; 121
            retlw       0x77        ; 119
            retlw       0x76        ; 118
            retlw       0x75        ; 117
            retlw       0x73        ; 115
            retlw       0x72        ; 114
            retlw       0x71        ; 113
            retlw       0x6F        ; 111
            retlw       0x6E        ; 110
            retlw       0x6D        ; 109
            retlw       0x6C        ; 108
            retlw       0x6B        ; 107
            retlw       0x69        ; 105
            retlw       0x68        ; 104
            retlw       0x67        ; 103
            retlw       0x66        ; 102
            retlw       0x65        ; 101
            retlw       0x64        ; 100
            retlw       0x63        ; 99
            retlw       0x62        ; 98
            retlw       0x61        ; 97
            retlw       0x60        ; 96; 365 B;  93.
;------------------------------------------------------------------------------
;  Predel90. 90%.
;------------------------------------------------------------------------------
Predel90    movlw       0x11        ;  .    W  17.
            movwf       PortC       ;    W
                                    ;   PortC.
            movlw       0x01        ;    W  1.
            movwf       PCLATH      ;    W   PCLATH.
            movlw       0x1A        ;    W  26.
            movwf       TaimerL     ;    W   TaimerL.
Nazad90     call        ADC         ;
            btfsc       Predelmax,0 ;
            goto        Stop        ;
            call        Table90     ;
            call        CCP         ;
;------------------------------------------------------------------------------
            movwf       ProvPred    ;    W
                                    ;   ProvPred.
            movlw       0x00        ;    W  0.
            xorwf       ProvPred,W  ;  "-" 
                                    ;  W  ProvPred.
            btfsc       Status,Z    ;  Z=1,   
                                    ;  bsf Max,0.
            goto        $+3         ;
            bcf         Max,0       ;      Max .
            goto        $+2         ;
            bsf         Max,0       ;      Max .
;------------------------------------------------------------------------------
            decfsz      TaimerL,F   ;    TaimerL.
            goto        Nazad90     ;      ,
                                    ;     Nazad90.
            goto        Opros       ;     ,
                                    ;     Opros.
;------------------------------------------------------------------------------
Table90    addwf       PCL,F       ;     
                                   ;       W.
            retlw       0xFF       ; 255; 182 B;  0.
            retlw       0xFF       ; 255
            retlw       0xFF       ; 255
            retlw       0xFF       ; 255
            retlw       0xFF       ; 255
            retlw       0xFF       ; 255
            retlw       0xFF       ; 255
            retlw       0xFF       ; 255
            retlw       0xFF       ; 255
            retlw       0xFF       ; 255
            retlw       0xFF       ; 255
            retlw       0xFF       ; 255
            retlw       0xFF       ; 255
            retlw       0xFF       ; 255; 208 B;  13.
            retlw       0xFC       ; 252
            retlw       0xF8       ; 248
            retlw       0xF3       ; 243
            retlw       0xEF       ; 239
            retlw       0xEB       ; 235
            retlw       0xE7       ; 231
            retlw       0xE3       ; 227
            retlw       0xDF       ; 223
            retlw       0xDB       ; 219
            retlw       0xD8       ; 216
            retlw       0xD4       ; 212
            retlw       0xD0       ; 208
            retlw       0xCD       ; 205
            retlw       0xCA       ; 202
            retlw       0xC6       ; 198
            retlw       0xC3       ; 195
            retlw       0xC0       ; 192
            retlw       0xBD       ; 189
            retlw       0xBA       ; 186
            retlw       0xB7       ; 183
            retlw       0xB5       ; 181
            retlw       0xB2       ; 178
            retlw       0xAF       ; 175
            retlw       0xAD       ; 173
            retlw       0xAA       ; 170
            retlw       0xA8       ; 168
            retlw       0xA5       ; 165
            retlw       0xA3       ; 163
            retlw       0xA0       ; 160
            retlw       0x9E       ; 158
            retlw       0x9C       ; 156
            retlw       0x9A       ; 154
            retlw       0x98       ; 152
            retlw       0x96       ; 150
            retlw       0x93       ; 147
            retlw       0x91       ; 145
            retlw       0x90       ; 144
            retlw       0x8E       ; 142
            retlw       0x8C       ; 140
            retlw       0x8A       ; 138
            retlw       0x88       ; 136
            retlw       0x86       ; 134
            retlw       0x85       ; 133
            retlw       0x83       ; 131
            retlw       0x81       ; 129
            retlw       0x80       ; 128
            retlw       0x7E       ; 126; 300 ;  60.
            retlw       0x7C       ; 124
            retlw       0x7B       ; 123
            retlw       0x79       ; 121
            retlw       0x78       ; 120
            retlw       0x76       ; 118
            retlw       0x75       ; 117
            retlw       0x74       ; 116
            retlw       0x72       ; 114
            retlw       0x71       ; 113
            retlw       0x70       ; 112
            retlw       0x6E       ; 110
            retlw       0x6D       ; 109
            retlw       0x6C       ; 108
            retlw       0x6B       ; 107
            retlw       0x69       ; 105
            retlw       0x68       ; 104
            retlw       0x67       ; 103
            retlw       0x66       ; 102
            retlw       0x65       ; 101
            retlw       0x64       ; 100
            retlw       0x63       ; 99
            retlw       0x61       ; 97
            retlw       0x60       ; 96
            retlw       0x5F       ; 95
            retlw       0x5E       ; 94
            retlw       0x5D       ; 93
            retlw       0x5C       ; 92
            retlw       0x5B       ; 91
            retlw       0x5B       ; 91
            retlw       0x5A       ; 90
            retlw       0x59       ; 89
            retlw       0x58       ; 88
            retlw       0x57       ; 87; 365 B;  93.

            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
;------------------------------------------------------------------------------
;  Predel80. 80%.
;------------------------------------------------------------------------------
Predel80    movlw       0x10        ;  .    W  16.
            movwf       PortC       ;    W
                                    ;   PortC.
            movlw       0x02        ;    W  2.
            movwf       PCLATH      ;    W   PCLATH.
            movlw       0x1A        ;    W  26.
            movwf       TaimerL     ;    W   TaimerL.
Nazad80     call        ADC         ;
            btfsc       Predelmax,0 ;
            goto        Stop        ;
            call        Table80     ;
            call        CCP         ;
;------------------------------------------------------------------------------
            movwf       ProvPred    ;    W
                                    ;   ProvPred.
            movlw       0x00        ;    W  0.
            xorwf       ProvPred,W  ;  "-" 
                                    ;  W  ProvPred.
            btfsc       Status,Z    ;  Z=1,   
                                    ;  bsf Max,0.
            goto        $+3         ;
            bcf         Max,0       ;      Max .
            goto        $+2         ;
            bsf         Max,0       ;      Max .
;------------------------------------------------------------------------------
            decfsz      TaimerL,F   ;    TaimerL.
            goto        Nazad80     ;      ,
                                    ;     Nazad80.
            goto        Opros       ;     ,
                                    ;     Opros.
;------------------------------------------------------------------------------
Table80    addwf       PCL,F       ;     
                                   ;       W.
            retlw       0xFF       ; 255; 182 B;  0.
            retlw       0xFF       ; 255
            retlw       0xFF       ; 255
            retlw       0xFF       ; 255
            retlw       0xFF       ; 255       
            retlw       0xFF       ; 255
            retlw       0xFF       ; 255
            retlw       0xFF       ; 255; 196 B;  7.
            retlw       0xFC       ; 252
            retlw       0xF7       ; 247
            retlw       0xF2       ; 242
            retlw       0xEE       ; 238
            retlw       0xE9       ; 233
            retlw       0xE5       ; 229
            retlw       0xE1       ; 225
            retlw       0xDD       ; 221
            retlw       0xD9       ; 217
            retlw       0xD5       ; 213
            retlw       0xD1       ; 209
            retlw       0xCE       ; 206
            retlw       0xCA       ; 202
            retlw       0xC7       ; 199
            retlw       0xC3       ; 195
            retlw       0xC0       ; 192
            retlw       0xBD       ; 189
            retlw       0xBA       ; 186
            retlw       0xB7       ; 183
            retlw       0xB4       ; 180
            retlw       0xB1       ; 177
            retlw       0xAE       ; 174
            retlw       0xAB       ; 171
            retlw       0xA9       ; 169
            retlw       0xA6       ; 166
            retlw       0xA4       ; 164
            retlw       0xA1       ; 161
            retlw       0x9F       ; 159
            retlw       0x9C       ; 156
            retlw       0x9A       ; 154
            retlw       0x98       ; 152
            retlw       0x96       ; 150
            retlw       0x93       ; 147
            retlw       0x91       ; 145
            retlw       0x8F       ; 143
            retlw       0x8D       ; 141
            retlw       0x8B       ; 139
            retlw       0x89       ; 137
            retlw       0x87       ; 135
            retlw       0x85       ; 133
            retlw       0x84       ; 132
            retlw       0x82       ; 130
            retlw       0x80       ; 128
            retlw       0x7E       ; 126
            retlw       0x7D       ; 125
            retlw       0x7B       ; 123
            retlw       0x7A       ; 122
            retlw       0x78       ; 120
            retlw       0x76       ; 118
            retlw       0x75       ; 117
            retlw       0x73       ; 115
            retlw       0x72       ; 114
            retlw       0x71       ; 113; 300 ;  60.
            retlw       0x6F       ; 111
            retlw       0x6E       ; 110
            retlw       0x6C       ; 108
            retlw       0x6B       ; 107
            retlw       0x6A       ; 106
            retlw       0x69       ; 105
            retlw       0x67       ; 103
            retlw       0x66       ; 102
            retlw       0x65       ; 101
            retlw       0x64       ; 100
            retlw       0x63       ; 99
            retlw       0x61       ; 97
            retlw       0x60       ; 96
            retlw       0x5F       ; 95
            retlw       0x5E       ; 94
            retlw       0x5D       ; 93
            retlw       0x5C       ; 92
            retlw       0x5B       ; 91
            retlw       0x5A       ; 90
            retlw       0x59       ; 89
            retlw       0x58       ; 88
            retlw       0x57       ; 87
            retlw       0x56       ; 86
            retlw       0x55       ; 85
            retlw       0x54       ; 84
            retlw       0x54       ; 84
            retlw       0x53       ; 83
            retlw       0x52       ; 82
            retlw       0x51       ; 81
            retlw       0x50       ; 80
            retlw       0x4F       ; 79
            retlw       0x4F       ; 79
            retlw       0x4E       ; 78; 365 B;  93.
;------------------------------------------------------------------------------
;  Predel70. 70%.
;------------------------------------------------------------------------------
Predel70    movlw       0x07        ;  .    W  7.
            movwf       PortC       ;    W
                                    ;   PortC.
            movlw       0x02        ;    W  2.
            movwf       PCLATH      ;    W   PCLATH.
            movlw       0x1A        ;    W  26.
            movwf       TaimerL     ;    W   TaimerL.
Nazad70     call        ADC         ;
            btfsc       Predelmax,0 ;
            goto        Stop        ;
            call        Table70     ;
            call        CCP         ;
;------------------------------------------------------------------------------
            movwf       ProvPred    ;    W
                                    ;   ProvPred.
            movlw       0x00        ;    W  0.
            xorwf       ProvPred,W  ;  "-" 
                                    ;  W  ProvPred.
            btfsc       Status,Z    ;  Z=1,   
                                    ;  bsf Max,0.
            goto        $+3         ;
            bcf         Max,0       ;      Max .
            goto        $+2         ;
            bsf         Max,0       ;      Max .
;------------------------------------------------------------------------------
            decfsz      TaimerL,F   ;    TaimerL.
            goto        Nazad70     ;      ,
                                    ;     Nazad70.
            goto        Opros       ;     ,
                                    ;     Opros.
;------------------------------------------------------------------------------
Table70     addwf       PCL,F       ;     
                                    ;       W.
            retlw       0xFF        ; 255; 182 B;  0.
            retlw       0xFE        ; 254
            retlw       0xF9        ; 249
            retlw       0xF4        ; 244
            retlw       0xEF        ; 239
            retlw       0xEA        ; 234
            retlw       0xE6        ; 230
            retlw       0xE1        ; 225
            retlw       0xDD        ; 221
            retlw       0xD9        ; 217
            retlw       0xD5        ; 213
            retlw       0xD1        ; 209
            retlw       0xCD        ; 205
            retlw       0xC9        ; 201
            retlw       0xC5        ; 197
            retlw       0xC2        ; 194
            retlw       0xBE        ; 190
            retlw       0xBB        ; 187
            retlw       0xB8        ; 184
            retlw       0xB5        ; 181
            retlw       0xB2        ; 178
            retlw       0xAF        ; 175
            retlw       0xAC        ; 172
            retlw       0xA9        ; 169
            retlw       0xA6        ; 166
            retlw       0xA3        ; 163
            retlw       0xA1        ; 161
            retlw       0x9E        ; 158
            retlw       0x9B        ; 155
            retlw       0x99        ; 153
            retlw       0x97        ; 151
            retlw       0x94        ; 148
            retlw       0x92        ; 146
            retlw       0x90        ; 144
            retlw       0x8E        ; 142
            retlw       0x8B        ; 139
            retlw       0x89        ; 137
            retlw       0x87        ; 135
            retlw       0x85        ; 133
            retlw       0x83        ; 131
            retlw       0x82        ; 130
            retlw       0x80        ; 128
            retlw       0x7E        ; 126
            retlw       0x7C        ; 124
            retlw       0x7A        ; 122
            retlw       0x79        ; 121
            retlw       0x77        ; 119
            retlw       0x75        ; 117
            retlw       0x74        ; 116
            retlw       0x72        ; 114
            retlw       0x71        ; 113
            retlw       0x6F        ; 111
            retlw       0x6E        ; 110
            retlw       0x6C        ; 108
            retlw       0x6B        ; 107
            retlw       0x6A        ; 106
            retlw       0x68        ; 104
            retlw       0x67        ; 103
            retlw       0x66        ; 102
            retlw       0x64        ; 100
            retlw       0x63        ; 99; 300 ;  60.
            retlw       0x62        ; 98
            retlw       0x61        ; 97
            retlw       0x60        ; 96
            retlw       0x5E        ; 94
            retlw       0x5D        ; 93
            retlw       0x5C        ; 92
            retlw       0x5B        ; 91
            retlw       0x5A        ; 90
            retlw       0x59        ; 89
            retlw       0x58        ; 88
            retlw       0x57        ; 87
            retlw       0x56        ; 86
            retlw       0x55        ; 85
            retlw       0x54        ; 84
            retlw       0x53        ; 83
            retlw       0x52        ; 82
            retlw       0x51        ; 81
            retlw       0x50        ; 80
            retlw       0x4F        ; 79
            retlw       0x4F        ; 79
            retlw       0x4E        ; 78
            retlw       0x4D        ; 77
            retlw       0x4C        ; 76
            retlw       0x4B        ; 75
            retlw       0x4B        ; 75
            retlw       0x4A        ; 74
            retlw       0x49        ; 73
            retlw       0x48        ; 72
            retlw       0x48        ; 72
            retlw       0x47        ; 71
            retlw       0x46        ; 70
            retlw       0x45        ; 69
            retlw       0x45        ; 69; 365 B;  93.

            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
;------------------------------------------------------------------------------
;  Predel60. 60%.
;------------------------------------------------------------------------------
Predel60    movlw       0x06        ;  .    W  6.
            movwf       PortC       ;    W
                                    ;   PortC.
            movlw       0x03        ;    W  3.
            movwf       PCLATH      ;    W   PCLATH.
            movlw       0x1A        ;    W  26.
            movwf       TaimerL     ;    W   TaimerL.
Nazad60     call        ADC         ;
            btfsc       Predelmax,0 ;
            goto        Stop        ;
            call        Table60     ;
            call        CCP         ;
            bcf         Max,0       ;      Max .
            decfsz      TaimerL,F   ;    TaimerL.
            goto        Nazad60     ;      ,
                                    ;     Nazad60.
            goto        Opros       ;     ,
                                    ;     Opros.
;------------------------------------------------------------------------------
Table60     addwf       PCL,F       ;     
                                    ;       W.
            retlw       0xDF        ; 223; 182 B;  0.
            retlw       0xDB        ; 219
            retlw       0xD6        ; 214
            retlw       0xD2        ; 210
            retlw       0xCE        ; 206
            retlw       0xCA        ; 202
            retlw       0xC6        ; 198
            retlw       0xC2        ; 194
            retlw       0xBE        ; 190
            retlw       0xBB        ; 187
            retlw       0xB7        ; 183
            retlw       0xB4        ; 180
            retlw       0xB0        ; 176
            retlw       0xAD        ; 173
            retlw       0xAA        ; 170
            retlw       0xA7        ; 167
            retlw       0xA4        ; 164
            retlw       0xA1        ; 161
            retlw       0x9E        ; 158
            retlw       0x9C        ; 156
            retlw       0x99        ; 153
            retlw       0x96        ; 150
            retlw       0x94        ; 148
            retlw       0x91        ; 145
            retlw       0x8F        ; 143
            retlw       0x8D        ; 141
            retlw       0x8A        ; 138
            retlw       0x88        ; 136
            retlw       0x86        ; 134
            retlw       0x84        ; 132
            retlw       0x82        ; 130
            retlw       0x80        ; 128
            retlw       0x7E        ; 126
            retlw       0x7C        ; 124
            retlw       0x7A        ; 122
            retlw       0x78        ; 120
            retlw       0x76        ; 118
            retlw       0x75        ; 117
            retlw       0x73        ; 115
            retlw       0x71        ; 113
            retlw       0x70        ; 112
            retlw       0x6E        ; 110
            retlw       0x6D        ; 109
            retlw       0x6B        ; 107
            retlw       0x6A        ; 106
            retlw       0x68        ; 104
            retlw       0x67        ; 103
            retlw       0x65        ; 101
            retlw       0x64        ; 100
            retlw       0x63        ; 99
            retlw       0x61        ; 97
            retlw       0x60        ; 96
            retlw       0x5F        ; 95
            retlw       0x5E        ; 94
            retlw       0x5C        ; 92
            retlw       0x5B        ; 91
            retlw       0x5A        ; 90
            retlw       0x59        ; 89
            retlw       0x58        ; 88
            retlw       0x57        ; 87
            retlw       0x56        ; 86; 300 ;  60.
            retlw       0x55        ; 85
            retlw       0x54        ; 84
            retlw       0x53        ; 83
            retlw       0x52        ; 82
            retlw       0x51        ; 81
            retlw       0x50        ; 80
            retlw       0x4F        ; 79
            retlw       0x4E        ; 78
            retlw       0x4D        ; 77
            retlw       0x4C        ; 76
            retlw       0x4B        ; 75
            retlw       0x4A        ; 74
            retlw       0x4A        ; 74
            retlw       0x49        ; 73
            retlw       0x48        ; 72
            retlw       0x47        ; 71
            retlw       0x46        ; 70
            retlw       0x46        ; 70
            retlw       0x45        ; 69
            retlw       0x44        ; 68
            retlw       0x43        ; 67
            retlw       0x43        ; 67
            retlw       0x42        ; 66
            retlw       0x41        ; 65
            retlw       0x41        ; 65
            retlw       0x40        ; 64
            retlw       0x3F        ; 63
            retlw       0x3F        ; 63
            retlw       0x3E        ; 62
            retlw       0x3D        ; 61
            retlw       0x3D        ; 61
            retlw       0x3C        ; 60
            retlw       0x3C        ; 60; 365 B;  93.
;------------------------------------------------------------------------------
;  Predel50. 50%.
;------------------------------------------------------------------------------
Predel50    movlw       0x05        ;  .    W  5.
            movwf       PortC       ;    W
                                    ;   PortC.
            movlw       0x03        ;    W  3.
            movwf       PCLATH      ;    W   PCLATH.
            movlw       0x1A        ;    W  26.
            movwf       TaimerL     ;    W   TaimerL.
Nazad50     call        ADC         ;
            btfsc       Predelmax,0 ;
            goto        Stop        ;
            call        Table50     ;
            call        CCP         ;
            bcf         Max,0       ;      Max .
            decfsz      TaimerL,F   ;    TaimerL.
            goto        Nazad50     ;      ,
                                    ;     Nazad50.
            goto        Opros       ;     ,
                                    ;     Opros.
;------------------------------------------------------------------------------
Table50     addwf       PCL,F       ;     
                                    ;       W.
            retlw       0xBB        ; 187; 182 B;  0.
            retlw       0xB7        ; 183
            retlw       0xB3        ; 179
            retlw       0xB0        ; 176
            retlw       0xAC        ; 172
            retlw       0xA9        ; 169
            retlw       0xA6        ; 166
            retlw       0xA2        ; 162
            retlw       0x9F        ; 159
            retlw       0x9C        ; 156
            retlw       0x99        ; 153
            retlw       0x96        ; 150
            retlw       0x94        ; 148
            retlw       0x91        ; 145
            retlw       0x8E        ; 142
            retlw       0x8C        ; 140
            retlw       0x89        ; 137
            retlw       0x87        ; 135
            retlw       0x85        ; 133
            retlw       0x82        ; 130
            retlw       0x80        ; 128
            retlw       0x7E        ; 126
            retlw       0x7C        ; 124
            retlw       0x7A        ; 122
            retlw       0x78        ; 120
            retlw       0x76        ; 118
            retlw       0x74        ; 116
            retlw       0x72        ; 114
            retlw       0x70        ; 112
            retlw       0x6F        ; 111
            retlw       0x6D        ; 109
            retlw       0x6B        ; 107
            retlw       0x6A        ; 106
            retlw       0x68        ; 104
            retlw       0x67        ; 103
            retlw       0x65        ; 101
            retlw       0x64        ; 100
            retlw       0x62        ; 98
            retlw       0x61        ; 97
            retlw       0x5F        ; 95
            retlw       0x5E        ; 94
            retlw       0x5D        ; 93
            retlw       0x5B        ; 91
            retlw       0x5A        ; 90
            retlw       0x59        ; 89
            retlw       0x58        ; 88
            retlw       0x56        ; 86
            retlw       0x55        ; 85
            retlw       0x54        ; 84
            retlw       0x53        ; 83
            retlw       0x52        ; 82
            retlw       0x51        ; 81
            retlw       0x50        ; 80
            retlw       0x4F        ; 79
            retlw       0x4E        ; 78
            retlw       0x4D        ; 77
            retlw       0x4C        ; 76
            retlw       0x4B        ; 75
            retlw       0x4A        ; 74
            retlw       0x49        ; 73
            retlw       0x48        ; 72; 300 ;  60.
            retlw       0x47        ; 71
            retlw       0x46        ; 70
            retlw       0x46        ; 70
            retlw       0x45        ; 69
            retlw       0x44        ; 68
            retlw       0x43        ; 67
            retlw       0x42        ; 66
            retlw       0x42        ; 66
            retlw       0x41        ; 65
            retlw       0x40        ; 64
            retlw       0x40        ; 64
            retlw       0x3F        ; 63
            retlw       0x3E        ; 62
            retlw       0x3D        ; 61
            retlw       0x3D        ; 61
            retlw       0x3C        ; 60
            retlw       0x3B        ; 59
            retlw       0x3B        ; 59
            retlw       0x3A        ; 58
            retlw       0x3A        ; 58
            retlw       0x39        ; 57
            retlw       0x38        ; 56
            retlw       0x38        ; 56
            retlw       0x37        ; 55
            retlw       0x37        ; 55
            retlw       0x36        ; 54
            retlw       0x36        ; 54
            retlw       0x35        ; 53
            retlw       0x35        ; 53
            retlw       0x34        ; 52
            retlw       0x33        ; 51
            retlw       0x33        ; 51
            retlw       0x32        ; 50; 365 B;  93.

            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
;------------------------------------------------------------------------------
;  Predel40. 40%.
;------------------------------------------------------------------------------
Predel40    movlw       0x04        ;  .    W  4.
            movwf       PortC       ;    W
                                    ;   PortC.
            movlw       0x04        ;    W  4.
            movwf       PCLATH      ;    W   PCLATH.
            movlw       0x1A        ;    W  26.
            movwf       TaimerL     ;    W   TaimerL.
Nazad40     call        ADC         ;
            btfsc       Predelmax,0 ;
            goto        Stop        ;
            call        Table40     ;
            call        CCP         ;
            bcf         Max,0       ;      Max .
            decfsz      TaimerL,F   ;    TaimerL.
            goto        Nazad40     ;      ,
                                    ;     Nazad40.
            goto        Opros       ;     ,
                                    ;     Opros.
;------------------------------------------------------------------------------
Table40     addwf       PCL,F       ;     
                                    ;       W.
            retlw       0x97        ; 151; 182 B;  0.
            retlw       0x93        ; 147
            retlw       0x90        ; 144
            retlw       0x8E        ; 142
            retlw       0x8B        ; 139
            retlw       0x88        ; 136
            retlw       0x85        ; 133
            retlw       0x83        ; 131
            retlw       0x80        ; 128
            retlw       0x7E        ; 126
            retlw       0x7C        ; 124
            retlw       0x79        ; 121
            retlw       0x77        ; 119
            retlw       0x75        ; 117
            retlw       0x73        ; 115
            retlw       0x71        ; 113
            retlw       0x6F        ; 111
            retlw       0x6D        ; 109
            retlw       0x6B        ; 107
            retlw       0x69        ; 105
            retlw       0x68        ; 104
            retlw       0x66        ; 102
            retlw       0x64        ; 100
            retlw       0x63        ; 99
            retlw       0x61        ; 97
            retlw       0x5F        ; 95
            retlw       0x5E        ; 94
            retlw       0x5C        ; 92
            retlw       0x5B        ; 91
            retlw       0x5A        ; 90
            retlw       0x58        ; 88
            retlw       0x57        ; 87
            retlw       0x56        ; 86
            retlw       0x54        ; 84
            retlw       0x53        ; 83
            retlw       0x52        ; 82
            retlw       0x51        ; 81
            retlw       0x4F        ; 79
            retlw       0x4E        ; 78
            retlw       0x4D        ; 77
            retlw       0x4C        ; 76
            retlw       0x4B        ; 75
            retlw       0x4A        ; 74
            retlw       0x49        ; 73
            retlw       0x48        ; 72
            retlw       0x47        ; 71
            retlw       0x46        ; 70
            retlw       0x45        ; 69
            retlw       0x44        ; 68
            retlw       0x43        ; 67
            retlw       0x43        ; 67
            retlw       0x42        ; 66
            retlw       0x41        ; 65
            retlw       0x40        ; 64
            retlw       0x3F        ; 63
            retlw       0x3E        ; 62
            retlw       0x3E        ; 62
            retlw       0x3D        ; 61
            retlw       0x3C        ; 60
            retlw       0x3B        ; 59
            retlw       0x3B        ; 59; 300 ;  60.
            retlw       0x3A        ; 58
            retlw       0x39        ; 57
            retlw       0x39        ; 57
            retlw       0x38        ; 56
            retlw       0x37        ; 55
            retlw       0x37        ; 55
            retlw       0x36        ; 54
            retlw       0x36        ; 54
            retlw       0x35        ; 53
            retlw       0x34        ; 52
            retlw       0x34        ; 52
            retlw       0x33        ; 51
            retlw       0x33        ; 51
            retlw       0x32        ; 50
            retlw       0x32        ; 50
            retlw       0x31        ; 49
            retlw       0x31        ; 49
            retlw       0x30        ; 48
            retlw       0x30        ; 48
            retlw       0x2F        ; 47
            retlw       0x2F        ; 47
            retlw       0x2E        ; 46
            retlw       0x2E        ; 46
            retlw       0x2D        ; 45
            retlw       0x2D        ; 45
            retlw       0x2C        ; 44
            retlw       0x2C        ; 44
            retlw       0x2B        ; 43
            retlw       0x2B        ; 43
            retlw       0x2B        ; 43
            retlw       0x2A        ; 42
            retlw       0x2A        ; 42
            retlw       0x29        ; 41; 365 B;  93.
;------------------------------------------------------------------------------
;  Predel30. 30%.
;------------------------------------------------------------------------------
Predel30    movlw       0x03        ;  .    W  3.
            movwf       PortC       ;    W
                                    ;   PortC.
            movlw       0x04        ;    W  4.
            movwf       PCLATH      ;    W   PCLATH.
            movlw       0x1A        ;    W  26.
            movwf       TaimerL     ;    W   TaimerL.
Nazad30     call        ADC         ;
            btfsc       Predelmax,0 ;
            goto        Stop        ;
            call        Table30     ;
            call        CCP         ;
            bcf         Max,0       ;      Max .
            decfsz      TaimerL,F   ;    TaimerL.
            goto        Nazad30     ;      ,
                                    ;     Nazad30.
            goto        Opros       ;     ,
                                    ;     Opros.
;------------------------------------------------------------------------------
Table30     addwf       PCL,F       ;     
                                    ;       W.
            retlw       0x72        ; 114; 182 B;  0.
            retlw       0x70        ; 112
            retlw       0x6E        ; 110
            retlw       0x6B        ; 107
            retlw       0x69        ; 105
            retlw       0x67        ; 103
            retlw       0x65        ; 101
            retlw       0x63        ; 99
            retlw       0x62        ; 98
            retlw       0x60        ; 96
            retlw       0x5E        ; 94
            retlw       0x5C        ; 92
            retlw       0x5B        ; 91
            retlw       0x59        ; 89
            retlw       0x57        ; 87
            retlw       0x56        ; 86
            retlw       0x54        ; 84
            retlw       0x53        ; 83
            retlw       0x52        ; 82
            retlw       0x50        ; 80
            retlw       0x4F        ; 79
            retlw       0x4E        ; 78
            retlw       0x4C        ; 76
            retlw       0x4B        ; 75
            retlw       0x4A        ; 74
            retlw       0x49        ; 73
            retlw       0x48        ; 72
            retlw       0x47        ; 71
            retlw       0x45        ; 69
            retlw       0x44        ; 68
            retlw       0x43        ; 67
            retlw       0x42        ; 66
            retlw       0x41        ; 65
            retlw       0x40        ; 64
            retlw       0x40        ; 64
            retlw       0x3F        ; 63
            retlw       0x3E        ; 62
            retlw       0x3D        ; 61
            retlw       0x3C        ; 60
            retlw       0x3B        ; 59
            retlw       0x3A        ; 58
            retlw       0x3A        ; 58
            retlw       0x39        ; 57
            retlw       0x38        ; 56
            retlw       0x37        ; 55
            retlw       0x37        ; 55
            retlw       0x36        ; 54
            retlw       0x35        ; 53
            retlw       0x34        ; 52
            retlw       0x34        ; 52
            retlw       0x33        ; 51
            retlw       0x33        ; 51
            retlw       0x32        ; 50
            retlw       0x31        ; 49
            retlw       0x31        ; 49
            retlw       0x30        ; 48
            retlw       0x30        ; 48
            retlw       0x2F        ; 47
            retlw       0x2E        ; 46
            retlw       0x2E        ; 46
            retlw       0x2D        ; 45; 300 ;  60.
            retlw       0x2D        ; 45
            retlw       0x2C        ; 44
            retlw       0x2C        ; 44
            retlw       0x2B        ; 43
            retlw       0x2B        ; 43
            retlw       0x2A        ; 42
            retlw       0x2A        ; 42
            retlw       0x29        ; 41
            retlw       0x29        ; 41
            retlw       0x29        ; 41
            retlw       0x28        ; 40
            retlw       0x28        ; 40
            retlw       0x27        ; 39
            retlw       0x27        ; 39
            retlw       0x26        ; 38
            retlw       0x26        ; 38
            retlw       0x26        ; 38
            retlw       0x25        ; 37
            retlw       0x25        ; 37
            retlw       0x25        ; 37
            retlw       0x24        ; 36
            retlw       0x24        ; 36
            retlw       0x23        ; 35
            retlw       0x23        ; 35
            retlw       0x23        ; 35
            retlw       0x22        ; 34
            retlw       0x22        ; 34
            retlw       0x22        ; 34
            retlw       0x22        ; 34
            retlw       0x21        ; 33
            retlw       0x21        ; 33
            retlw       0x21        ; 33
            retlw       0x20        ; 32; 365 B;  93.

            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
            nop                     ;
;------------------------------------------------------------------------------
;  Predel20. 20%.
;------------------------------------------------------------------------------
Predel20    movlw       0x02        ;  .    W  2.
            movwf       PortC       ;    W
                                    ;   PortC.
            movlw       0x05        ;    W  5.
            movwf       PCLATH      ;    W   PCLATH.
            movlw       0x1A        ;    W  26.
            movwf       TaimerL     ;    W   TaimerL.
Nazad20     call        ADC         ;
            btfsc       Predelmax,0 ;
            goto        Stop        ;
            call        Table20     ;
            call        CCP         ;
            bcf         Max,0       ;      Max .
            decfsz      TaimerL,F   ;    TaimerL.
            goto        Nazad20     ;      ,
                                    ;     Nazad20.
            goto        Opros       ;     ,
                                    ;     Opros.
;------------------------------------------------------------------------------
Table20     addwf       PCL,F       ;     
                                    ;       W.
            retlw       0x4E        ; 78; 182 B;  0.
            retlw       0x4C        ; 76
            retlw       0x4B        ; 75
            retlw       0x49        ; 73
            retlw       0x48        ; 72
            retlw       0x47        ; 71
            retlw       0x45        ; 69
            retlw       0x44        ; 68
            retlw       0x43        ; 67
            retlw       0x42        ; 66
            retlw       0x40        ; 64
            retlw       0x3F        ; 63
            retlw       0x3E        ; 62
            retlw       0x3D        ; 61
            retlw       0x3C        ; 60
            retlw       0x3B        ; 59
            retlw       0x3A        ; 58
            retlw       0x39        ; 57
            retlw       0x38        ; 56
            retlw       0x37        ; 55
            retlw       0x36        ; 54
            retlw       0x35        ; 53
            retlw       0x35        ; 53
            retlw       0x34        ; 52
            retlw       0x33        ; 51
            retlw       0x32        ; 50
            retlw       0x31        ; 49
            retlw       0x31        ; 49
            retlw       0x30        ; 48
            retlw       0x2F        ; 47
            retlw       0x2F        ; 47
            retlw       0x2E        ; 46
            retlw       0x2D        ; 45
            retlw       0x2D        ; 45
            retlw       0x2C        ; 44
            retlw       0x2B        ; 43
            retlw       0x2B        ; 43
            retlw       0x2A        ; 42
            retlw       0x2A        ; 42
            retlw       0x29        ; 41
            retlw       0x29        ; 41
            retlw       0x28        ; 40
            retlw       0x28        ; 40
            retlw       0x27        ; 39
            retlw       0x27        ; 39
            retlw       0x26        ; 38
            retlw       0x26        ; 38
            retlw       0x25        ; 37
            retlw       0x25        ; 37
            retlw       0x24        ; 36
            retlw       0x24        ; 36
            retlw       0x23        ; 35
            retlw       0x23        ; 35
            retlw       0x23        ; 35
            retlw       0x22        ; 34
            retlw       0x22        ; 34
            retlw       0x21        ; 33
            retlw       0x21        ; 33
            retlw       0x21        ; 33
            retlw       0x20        ; 32
            retlw       0x20        ; 32; 300 ;  60.
            retlw       0x20        ; 32
            retlw       0x1F        ; 31
            retlw       0x1F        ; 31
            retlw       0x1F        ; 31
            retlw       0x1E        ; 30
            retlw       0x1E        ; 30
            retlw       0x1E        ; 30
            retlw       0x1D        ; 29
            retlw       0x1D        ; 29
            retlw       0x1D        ; 29
            retlw       0x1C        ; 28
            retlw       0x1C        ; 28
            retlw       0x1C        ; 28
            retlw       0x1C        ; 28
            retlw       0x1B        ; 27
            retlw       0x1B        ; 27
            retlw       0x1B        ; 27
            retlw       0x1B        ; 27
            retlw       0x1A        ; 26
            retlw       0x1A        ; 26
            retlw       0x1A        ; 26
            retlw       0x1A        ; 26
            retlw       0x19        ; 25
            retlw       0x19        ; 25
            retlw       0x19        ; 25
            retlw       0x19        ; 25
            retlw       0x18        ; 24
            retlw       0x18        ; 24
            retlw       0x18        ; 24
            retlw       0x18        ; 24
            retlw       0x18        ; 24
            retlw       0x17        ; 23
            retlw       0x17        ; 23; 365 B;  93.
;------------------------------------------------------------------------------
;  Predel10. 10%.
;------------------------------------------------------------------------------
Predel10    movlw       0x01        ;  .    W  1.
            movwf       PortC       ;    W
                                    ;   PortC.
            movlw       0x05        ;    W  5.
            movwf       PCLATH      ;    W   PCLATH.
            movlw       0x1A        ;    W  26.
            movwf       TaimerL     ;    W   TaimerL.
Nazad10     call        ADC         ;
            btfsc       Predelmax,0 ;
            goto        Stop        ;
            call        Table10     ;
            call        CCP         ;
            bcf         Max,0       ;      Max .
            decfsz      TaimerL,F   ;    TaimerL.
            goto        Nazad10     ;      ,
                                    ;     Nazad10.
            goto        Opros       ;     ,
                                    ;     Opros.
;------------------------------------------------------------------------------
Table10     addwf       PCL,F       ;     
                                    ;       W.
            retlw       0x29        ; 41; 182 B;  0.
            retlw       0x29        ; 41
            retlw       0x28        ; 40
            retlw       0x27        ; 39
            retlw       0x26        ; 38
            retlw       0x26        ; 38
            retlw       0x25        ; 37
            retlw       0x24        ; 36
            retlw       0x24        ; 36
            retlw       0x23        ; 35
            retlw       0x23        ; 35
            retlw       0x22        ; 34
            retlw       0x22        ; 34
            retlw       0x21        ; 33
            retlw       0x20        ; 32
            retlw       0x20        ; 32
            retlw       0x1F        ; 31
            retlw       0x1F        ; 31
            retlw       0x1F        ; 31
            retlw       0x1E        ; 30
            retlw       0x1E        ; 30
            retlw       0x1D        ; 29
            retlw       0x1D        ; 29
            retlw       0x1C        ; 28
            retlw       0x1C        ; 28
            retlw       0x1C        ; 28
            retlw       0x1B        ; 27
            retlw       0x1B        ; 27
            retlw       0x1A        ; 26
            retlw       0x1A        ; 26
            retlw       0x1A        ; 26
            retlw       0x19        ; 25
            retlw       0x19        ; 25
            retlw       0x19        ; 25
            retlw       0x19        ; 25
            retlw       0x18        ; 24
            retlw       0x18        ; 24
            retlw       0x18        ; 24
            retlw       0x17        ; 23
            retlw       0x17        ; 23
            retlw       0x17        ; 23
            retlw       0x17        ; 23
            retlw       0x16        ; 22
            retlw       0x16        ; 22
            retlw       0x16        ; 22
            retlw       0x16        ; 22
            retlw       0x15        ; 21
            retlw       0x15        ; 21
            retlw       0x15        ; 21
            retlw       0x15        ; 21
            retlw       0x14        ; 20
            retlw       0x14        ; 20
            retlw       0x14        ; 20
            retlw       0x14        ; 20
            retlw       0x14        ; 20
            retlw       0x13        ; 19
            retlw       0x13        ; 19
            retlw       0x13        ; 19
            retlw       0x13        ; 19
            retlw       0x13        ; 19
            retlw       0x12        ; 18; 300 ;  60.
            retlw       0x12        ; 18
            retlw       0x12        ; 18
            retlw       0x12        ; 18
            retlw       0x12        ; 18
            retlw       0x12        ; 18
            retlw       0x11        ; 17
            retlw       0x11        ; 17
            retlw       0x11        ; 17
            retlw       0x11        ; 17
            retlw       0x11        ; 17
            retlw       0x11        ; 17
            retlw       0x11        ; 17
            retlw       0x10        ; 16
            retlw       0x10        ; 16
            retlw       0x10        ; 16
            retlw       0x10        ; 16
            retlw       0x10        ; 16
            retlw       0x10        ; 16
            retlw       0x10        ; 16
            retlw       0x10        ; 16
            retlw       0x0F        ; 15
            retlw       0x0F        ; 15
            retlw       0x0F        ; 15
            retlw       0x0F        ; 15
            retlw       0x0F        ; 15
            retlw       0x0F        ; 15
            retlw       0x0F        ; 15
            retlw       0x0F        ; 15
            retlw       0x0F        ; 15
            retlw       0x0E        ; 14
            retlw       0x0E        ; 14
            retlw       0x0E        ; 14
            retlw       0x0E        ; 14; 365 B;  93.

            end                     ;  .